/*
 * Jaired Jawed (jaireddjawed.7@gmail.com)
 * Sep 22, 2018
 * Azlo API Wrapper v0.12
 */

var request = require('request');
var baseURL = 'https://developer-api.azlo.com/v1';

module.exports = function (apiKey) {
  var baseRequest = {
    json: true,
    method: 'GET',
    headers: {
      Authorization: apiKey,
    },
  };

  return {
    /**
     * queryParams
     * callback
     */
    accounts: function (queryParams, callback = null) {
      baseRequest.url = `${baseURL}/accounts?unmask=${queryParams.unmask}`;

      var getAccounts = function(resolve, reject) {
        request(baseRequest, function (error, response, body) {
          if (error) {
            reject(error);
          } else {
            resolve(body);
          }
        });
      };

      return callback && typeof callback === 'function' ?
        getAccounts(callback.bind(null, undefined), callback) : new Promise(getAccounts);
    },
    tranactions: function () {
      baseRequest.url = `${baseURL}/transactions`;
    },
  };
};
